/**
 * @package n3tSeznamCaptcha
 * @author Pavel Poles - n3t.cz
 * @copyright (C) 2012 - Pavel Poles - n3t.cz
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

var n3tSeznamCaptcha = new Class({

	Implements: [Options],

	options: {
    'url': '',
    'audio': true,
		'text-reload': 'Reload challenge',
    'text-reload-title': 'Load new challenge',
    'text-audio': 'Audio challenge',
    'text-audio-title': 'Listen to the code audio version',
    'text-captcha': 'Captcha'
	},

  player: null,

	initialize: function(options) {
		this.setOptions(options);
    $$('.seznam-captcha').each((function(el){
      this.loadCaptcha(el);
    }).bind(this));
	},

	loadCaptcha: function(wrapper) {
    new Request( {
      method: 'get',
      emulation: false,
      url: this.options['url']+'captcha.create.php',
      onSuccess: (function(response, Xml) {
        this.createCaptcha(wrapper,response);
      }).bind(this)
    }).send();
  },

  supportsAudio: function() {
    return typeOf(window.Audio) != 'null' && !Browser.ie;
  },

  supportsEmbed: function() {
    if (Browser.ie) return true;
    return navigator.mimeTypes["audio/wav"] && navigator.mimeTypes["audio/wav"].enabledPlugin;
  },

	createCaptcha: function(wrapper, hash) {
    if (!wrapper.retrieve('hash')) {
      var el = new Element('img',{
        'class': 'seznam-captcha-image',
        'alt': this.options['text-captcha']
      }).inject(wrapper);
      wrapper.store('image',el);

      var controls = new Element('div',{
        'title': this.options['text-audio-title'],
        'class': 'seznam-captcha-controls'
      }).inject(wrapper);

      if (this.options['audio']) {
        wrapper.store('player',null);
        el = new Element('a',{
          'title': this.options['text-audio-title'],
          'class': 'seznam-captcha-audio'
        }).inject(controls);
        el.set('html','<span>'+this.options['text-audio']+'</span>');
        wrapper.store('audio',el);
        el.addEvent('click',(function(e){
          var wrapper = e.target.getParent('.seznam-captcha');
          var url=wrapper.retrieve('audio').get('href');
          var player = wrapper.retrieve('player');

          if (this.supportsAudio()) {
            if (player) player.dispose();
            player=new Audio(url);
            player.play();
            e.stop();
          } else if (this.supportsEmbed()) {
            if (!player)
              player = new Element('div',{
                'style': {
                  'display': 'none'
                }
              }).inject(wrapper);
            player.set('html','<embed src="'+url+'" autostart hidden type="audio/x-wav" />');
            e.stop();
          }
          wrapper.store('player',player);
        }).bind(this));
        el = new Element('br',{}).inject(controls);
      }

      el = new Element('a',{
        'href': '#',
        'title': this.options['text-reload-title'],
        'class': 'seznam-captcha-reload'
      }).inject(controls);
      el.set('html','<span>'+this.options['text-reload']+'</span>');
      el.addEvent('click', (function(e){
        this.loadCaptcha(e.target.getParent('.seznam-captcha'));
        e.stop();
      }).bind(this));

      el = new Element('input',{
        'type': 'hidden',
        'name': 'captcha_hash'
      }).inject(wrapper);
      wrapper.store('hash',el);

      el = new Element('input',{
        'type': 'text',
        'name': 'captcha_answer',
        'class': 'seznam-captcha-answer',
        'size': 5,
        'maxlength': 5
      }).inject(wrapper);
    }
    wrapper.retrieve('hash').set('value',hash);
    wrapper.retrieve('image').set('src','http://captcha.seznam.cz/captcha.getImage?hash='+hash);
    if (this.options['audio']) {
      if (!this.supportsAudio() && !this.supportsEmbed())
        wrapper.retrieve('audio').set('href',this.options['url']+'captcha.audio.php?hash='+hash+'&d=1');
      else
        wrapper.retrieve('audio').set('href','http://captcha.seznam.cz/captcha.getAudio?hash='+hash);
    }
	}

});