<?php
/**
 * @package n3tSeznamCaptcha
 * @author Pavel Poles - n3t.cz
 * @copyright (C) 2012 - Pavel Poles - n3t.cz
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgCaptchaN3tSeznamCaptcha extends JPlugin
{

	public function __construct($subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}
  
	public function onInit($id)
	{
		$doc = JFactory::getDocument();
    if ($this->params->def('theme', 'simple'))
      $doc->addStyleSheet( JURI::root(true)."/media/plg_n3tseznamcaptcha/css/".$this->params->def('theme', 'simple').".css" );
    $doc->addScript( JURI::root(true)."/media/plg_n3tseznamcaptcha/javascript/captcha.js" );
		$doc->addScriptDeclaration("
      window.addEvent('domready', function() {
        new n3tSeznamCaptcha({
          'url': '".JURI::root(true)."/plugins/captcha/n3tseznamcaptcha/',
          'audio': ".( $this->params->def('show_audio', 1) ? "true" : "false" ).",
          'text-captcha': '".JText::_('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_CAPTCHA',true)."',
          'text-reload': '".JText::_('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_RELOAD',true)."',
          'text-reload-title': '".JText::_('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_RELOAD_TITLE',true)."',
          'text-audio': '".JText::_('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_AUDIO',true)."',
          'text-audio-title': '".JText::_('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_AUDIO_TITLE',true)."'
        });
      });"
		);
    if( !ini_get('allow_url_fopen') && (!extension_loaded('curl') || !function_exists('curl_exec') ) ) {
      throw new Exception(JText::_('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_NO_DOWNLOAD_SUPPORT'));
    }
  }

	public function onDisplay($name, $id, $class)
	{
    return '<div class="seznam-captcha"></div>';
	}

	public function onCheckAnswer($code)
	{
		$hash	= JRequest::getString('captcha_hash', '');
		$answer	= JRequest::getString('captcha_answer', '');
		if ($hash == null || strlen($hash) == 0 || $hash == null || strlen($hash) == 0)
		{
			$this->_subject->setError(JText::_('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_EMPTY_ANSWER'));
			return false;
		}
    if ($this->_checkAnswer($hash, $answer)) return true;
		$this->_subject->setError(JText::_('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_WRONG_ANSWER'));
		return false;
  }

  private function _checkAnswer($hash, $answer)
  {
    $url = 'http://captcha.seznam.cz/captcha.check?hash='.$hash.'&code='.$answer;
    if (ini_get('allow_url_fopen')) {
      file_get_contents($url);
      if (isset($http_response_header)
      && is_array($http_response_header)
      && isset($http_response_header[0])
      && strpos($http_response_header[0],'200'))
        return true;
    } elseif (extension_loaded('curl') && function_exists('curl_exec')) {
      $c = curl_init();
      curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($c, CURLOPT_URL, $url);
      curl_exec($c);
      $info = curl_getinfo($c);
      curl_close($c);
      return $info['http_code'] == 200;
    }
    return false;
  }
}